  
#ifndef _calanalysis_cmpt_h_
#define _calanalysis_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/calanalysis/calanalysis_forward.h>

using namespace std;

namespace casac {
           


   class  calanalysis  {
       public :


         ~calanalysis();
         calanalysis();

         bool open(const  string& caltable=string(""));

         bool close();

         string calname();

         string msname();

         string viscal();

         string partype();

         string polbasis();

         int numfield();

         std::vector<std::string> field( bool  name=true);

         int numantenna();

         int numantenna1();

         int numantenna2();

         std::vector<std::string> antenna( bool  name=true);

         std::vector<std::string> antenna1( bool  name=true);

         std::vector<std::string> antenna2( bool  name=true);

         int numfeed();

         std::vector<std::string> feed();

         int numtime();

         std::vector<double>time();

         int numspw();

         std::vector<std::string> spw( bool  name=true);

         std::vector<int> numchannel();

         record* freq();

         record* get( const variant & field = variant(),  const variant & antenna = variant(),  const variant & timerange = variant(),  const variant & spw = variant(),  const variant & feed = variant(), const  string& axis=string("TIME"), const  string& ap=string("AMPLITUDE"),  bool  norm=false,  bool  unwrap=false, 
			  double jumpmax=0.0);

         record* fit( const variant & field = variant(),  const variant & antenna = variant(),  const variant & timerange = variant(),  const variant & spw = variant(),  const variant & feed = variant(), const  string& axis=string("TIME"), const  string& ap=string("AMPLITUDE"),  bool  norm=false,  bool  unwrap=false, 
			  double jumpmax=0.0, const  string& order=string("AVERAGE"), const  string& type=string("LSQ"),  bool  weight=false);


      private :
#include <tools/calanalysis/calanalysis_private.h>
   }; 

 
}
#endif
