  
#ifndef _calplot_cmpt_h_
#define _calplot_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/calibrater/calplot_forward.h>

using namespace std;

namespace casac {
           


   class  calplot  {
       public :


         ~calplot();
         calplot();

         bool close();

         bool done();

         bool next();

         bool open( const string& caltable=string(""));

         bool plot( const string& xaxis=string("time"),  const string& yaxis=string("time"));

         bool savefig( const string& filename=string(""),  int  dpi=-1,  const string& orientation=string(""),  const string& papertype=string(""),  const string& facecolor=string(""),  const string& edgecolor=string(""));

         bool plotoptions( int  subplot=111,  bool  overplot=false,  const string& iteration=string(""),  const std::vector<double>& plotrange=initialize_vector(1, (double)0.0),  bool  showflags=false,  const string& plotsymbol=string("."),  const string& plotcolor=string("green"), 
			  double markersize=5.0, 
			  double fontsize=10.0);

         bool markflags( int  panel=0,  const std::vector<double>& region=initialize_vector(1, (double)0.0));

         bool flagdata();

         bool locatedata();

         bool selectcal( const variant & antenna = variant(),  const variant & field = variant(),  const variant & spw = variant(),  const variant & time = variant(),  const string& poln=string(""));

         bool stopiter( bool  rmplotter=false);

         bool clearplot( int  subplot=000);


      private :
#include <tools/calibrater/calplot_private.h>
   }; 

 
}
#endif
