  
#ifndef _regionmanager_cmpt_h_
#define _regionmanager_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/images/regionmanager_forward.h>

using namespace std;

namespace casac {
           


   class  regionmanager  {
       public :


         ~regionmanager();
         regionmanager();

         string absreltype( int  absrelvalue=0);

         record* box( const std::vector<double>& blc=initialize_vector(1, (double)0),  const std::vector<double>& trc=initialize_vector(1, (double)-1),  const std::vector<double>& inc=initialize_vector(1, (double)1),  const string& absrel=string("abs"),  bool  frac=false,  const string& comment=string(""));

         record* frombcs( const record& csys=initialize_record("") ,  const  std::vector<int>& shape=initialize_vector(1, (int)0),  const string& box=string(""),  const string& chans=string(""),  const string& stokes=string(""),  const string& stokescontrol=string("a"),  const variant & region = variant());

         record* complement( const variant & region = variant(),  const string& comment=string(""));

         record* concatenation( const variant & box = variant(),  const variant & regions = variant(),  const string& comment=string(""));

         bool deletefromtable( const string& tablename=string(""),  const string& regionname=string(""));

         record* difference( const record& region1=initialize_record("") ,  const record& region2=initialize_record("") ,  const string& comment=string(""));

         bool done();

         std::vector<int> selectedchannels( const string& specification=string(""),  const  std::vector<int>& shape=initialize_vector(1, (int)0));

         record* fromtextfile( const string& filename=string(""),  const  std::vector<int>& shape=initialize_vector(1, (int)0),  const record& csys=initialize_record("") );

         record* fromtext( const string& text=string(""),  const  std::vector<int>& shape=initialize_vector(1, (int)1),  const record& csys=initialize_record("") );

         record* fromfiletorecord( const string& filename=string(""),  bool  verbose=true,  const string& regionname=string(""));

         bool tofile( const string& filename=string(""),  const record& region=initialize_record("") );

         string fromrecordtotable( const string& tablename=string(""),  const variant & regionname = variant(),  const record& regionrec=initialize_record("") ,  bool  asmask=false,  bool  verbose=true);

         record* fromtabletorecord( const string& tablename=string(""),  const variant & regionname = variant(),  bool  verbose=true);

         record* intersection( const variant & regions = variant(),  const string& comment=string(""));

         bool ispixelregion( const record& region=initialize_record("") );

         bool isworldregion( const record& region=initialize_record("") );

         std::vector<std::string> namesintable( const string& tablename=string(""));

         bool setcoordinates( const record& csys=initialize_record("") );

         record* makeunion( const variant & regions = variant(),  const string& comment=string(""));

         record* wbox( const variant & blc = variant(),  const variant & trc = variant(),  const  std::vector<int>& pixelaxes=initialize_vector(1, (int)-1),  const record& csys=initialize_record("") ,  const string& absrel=string("'abs'"),  const string& comment=string(""));

         record* wpolygon( const variant & x = variant(),  const variant & y = variant(),  const  std::vector<int>& pixelaxes=initialize_vector(1, (int)-1),  const record& csys=initialize_record("") ,  const string& absrel=string("abs"),  const string& comment=string(""));


      private :
#include <tools/images/regionmanager_private.h>
   }; 

 
}
#endif
