  
#ifndef _spectralline_cmpt_h_
#define _spectralline_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/spectralline/spectralline_forward.h>

using namespace std;

namespace casac {
           


   class  spectralline  {
       public :


         ~spectralline();
         spectralline();

         
                                      casac::spectralline* splattotable( const  std::vector<std::string>& filenames=std::vector<string>(1, ""),  const string& table=string(""));

         bool open( const string& table=string(""));

         bool close();

         bool done();

         
                                      casac::spectralline* search(const  string& outfile=string(""),  const std::vector<double>& freqrange=initialize_vector(1, (double)0),  const variant & species = variant(),  bool  reconly=false,  const variant & chemnames = variant(),  const std::vector<std::string>& qns=std::vector<string>(1, ""),  const std::vector<double>& intensity=initialize_vector(1, (double)-1),  const std::vector<double>& smu2=initialize_vector(1, (double)-1),  const std::vector<double>& loga=initialize_vector(1, (double)-1),  const std::vector<double>& el=initialize_vector(1, (double)-1),  const std::vector<double>& eu=initialize_vector(1, (double)-1),  bool  rrlinclude=true,  bool  rrlonly=false,  bool  verbose=true, const  string& logfile=string(""),  bool  append=false);

         void list();

         record* torecord();

         record* species( bool  verbose=false, const  string& logfile=string(""),  bool  append=false);

         record* chemnames( bool  verbose=false, const  string& logfile=string(""),  bool  append=false);

         int nrows();


      private :
#include <tools/spectralline/spectralline_private.h>
   }; 

 
}
#endif
